//+------------------------------------------------------------------+
//heyigeng
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#define             MAGICMA 2012
double              mafast0;
double              maslow0;
double              mafast1;
double              maslow1;
double              buyopenma;
double              sellopenma;
double              fastmahighest;
double              highback;
double              fastmalowest;
double              lowback;
extern double       MovingPeriodFast= 5;
extern double       MovingPeriodSlow= 140;
extern double       MovingShift=0;
int                 i;
int                 x;
bool                alreadybuy=false;
bool                alreadysell=false;
datetime            buyopentime;
datetime            sellopentime;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
    mafast0=iMA(NULL,0,MovingPeriodFast,MovingShift,MODE_SMA,PRICE_CLOSE,0);
    maslow0=iMA(NULL,0,MovingPeriodSlow,MovingShift,MODE_SMA,PRICE_CLOSE,0);
    mafast1=iMA(NULL,0,MovingPeriodFast,MovingShift,MODE_SMA,PRICE_CLOSE,1);
    maslow1=iMA(NULL,0,MovingPeriodSlow,MovingShift,MODE_SMA,PRICE_CLOSE,1);
    BuyorSell();
    TakeProfit();
    StopLoss();
//+------------------------------------------------------------------+
   return(0);
  }
//----------------------------------------------------------------------------------
void BuyorSell()
{
 if(mafast1<maslow1 && mafast0>maslow0 && alreadybuy==false)
   {
    OrderSend(Symbol(),OP_BUY,0.1,Ask,3,0,0,"",MAGICMA,0,Red);
    alreadybuy=true;
    buyopentime=TimeCurrent();
    buyopenma=mafast0;
   }
 if(mafast1>maslow1 && mafast0<maslow0 && alreadysell==false)
   {
    OrderSend(Symbol(),OP_SELL,0.1,Bid,3,0,0,"",MAGICMA,0,Blue);
    alreadysell=true;
    sellopentime=TimeCurrent();
    sellopenma=mafast0;
   }
}
//------------------------------------------------------------------------------------------
void TakeProfit()
{
 if(OrdersTotal()>0 )   
   {
    for(i=OrdersTotal()-1;i>=0;i--)
       {
        if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)  break;
        if(OrderType()==OP_BUY && mafast0>buyopenma)
          {
           FromHighBack();
           if(highback>0.1 && fastmahighest-buyopenma>400*Point)
             {
              RefreshRates();
              OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
              Print("takebuyprofit");
              alreadybuy=false;
             }
          }
       }
    for(i=OrdersTotal()-1;i>=0;i--)
       {
        if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)  break;
        if(OrderType()==OP_SELL && mafast0<sellopenma)
          {
           FromLowBack();
           if(lowback>0.1 && sellopenma-fastmalowest>400*Point)
             {
              RefreshRates();
              OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
              Print("takesellprofit");
              alreadysell=false;
             }
          }
       }             
   }
}
//--------------------------------------------------------------------------------------------
void FromHighBack()
{
 fastmahighest=iMA(NULL,0,MovingPeriodFast,MovingShift,MODE_SMA,PRICE_CLOSE,0);
 for(x=0;x<(TimeCurrent()-buyopentime)/60/Period();x++)
    {
     if(iMA(NULL,0,MovingPeriodFast,MovingShift,MODE_SMA,PRICE_CLOSE,x)>fastmahighest)
       fastmahighest=iMA(NULL,0,MovingPeriodFast,MovingShift,MODE_SMA,PRICE_CLOSE,x);
    }
 highback=(fastmahighest-mafast0)/(fastmahighest-buyopenma);
}
//--------------------------------------------------------------------------------------------
void FromLowBack()
{
 fastmalowest=iMA(NULL,0,MovingPeriodFast,MovingShift,MODE_SMA,PRICE_CLOSE,0);
 for(x=0;x<(TimeCurrent()-sellopentime)/60/Period();x++)
    {
     if(iMA(NULL,0,MovingPeriodFast,MovingShift,MODE_SMA,PRICE_CLOSE,x)<fastmalowest)
       fastmalowest=iMA(NULL,0,MovingPeriodFast,MovingShift,MODE_SMA,PRICE_CLOSE,x);
    }
 lowback=(mafast0-fastmalowest)/(sellopenma-fastmalowest);
}
//----------------------------------------------------------------------------------------------
void StopLoss()
{
 for(i=OrdersTotal()-1;i>=0;i--)
    {
     if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)  break;
     if(OrderType()==OP_BUY && mafast0<buyopenma)
       {
        if(buyopenma-mafast0>200*Point)
          {
           Print("stopbuyloss");
           OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
          }
       }
    }
  for(i=OrdersTotal()-1;i>=0;i--)
    {
     if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)  break;
     if(OrderType()==OP_SELL && mafast0>sellopenma)
       {
        if(mafast0-sellopenma>200*Point)
          {
           Print("stopsellloss");
           OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
          }
       }
    }
}